--- otp_src_R13B04/erts/emulator/beam/big.c	2009-11-20 21:29:23.000000000 +0800
+++ otp_src_R13B04_patched/erts/emulator/beam/big.c	2010-06-18 15:10:36.000000000 +0800
@@ -1485,14 +1485,14 @@
 	*hp = make_pos_bignum_header(2);
 	BIG_DIGIT(hp, 0) = (Uint) (x & ((Uint) 0xffffffff));
 	BIG_DIGIT(hp, 1) = (Uint) ((x >> 32) & ((Uint) 0xffffffff));
-	*hpp += 2;
+	*hpp += 3;
     }
     else
 #endif
     {
 	*hp = make_pos_bignum_header(1);
 	BIG_DIGIT(hp, 0) = (Uint) x;
-	*hpp += 1;
+	*hpp += 2;
     }
     return make_big(hp);
 }
@@ -1515,7 +1515,7 @@
 	    *hp = make_pos_bignum_header(2);
 	BIG_DIGIT(hp, 0) = (Uint) (x & ((Uint) 0xffffffff));
 	BIG_DIGIT(hp, 1) = (Uint) ((x >> 32) & ((Uint) 0xffffffff));
-	*hpp += 2;
+	*hpp += 3;
     }
     else
 #endif
@@ -1525,7 +1525,7 @@
 	else
 	    *hp = make_pos_bignum_header(1);
 	BIG_DIGIT(hp, 0) = (Uint) x;
-	*hpp += 1;
+	*hpp += 2;
     }
     return make_big(hp);
 }
--- otp_src_R13B04/erts/emulator/beam/utils.c	2010-02-20 02:03:15.000000000 +0800
+++ otp_src_R13B04_patched/erts/emulator/beam/utils.c	2010-06-18 17:20:19.000000000 +0800
@@ -364,7 +364,7 @@
     }
     else {
 	if (szp)
-	    *szp = ERTS_UINT64_HEAP_SIZE(ui64);
+	    *szp += ERTS_UINT64_HEAP_SIZE(ui64);
 	if (hpp)
 	    res = erts_uint64_to_big(ui64, hpp);
     }
@@ -381,7 +381,7 @@
     }
     else {
 	if (szp)
-	    *szp = ERTS_SINT64_HEAP_SIZE(si64);
+	    *szp += ERTS_SINT64_HEAP_SIZE(si64);
 	if (hpp)
 	    res = erts_sint64_to_big(si64, hpp);
     }
